unit StreamThreads;

interface

uses
  Windows, Messages, Classes,
  AbstractStreams;

const
  AM_HZ = WM_USER + $99;

type
  TStreamThread = class(TThread)
  public
    StreamWave: TARBWave;
    DI: LongWord;
    ClockHz: Double;
    Reps: Integer;
    bDone: Boolean;
  protected
    procedure Execute; override;
  end;

var
  LastReps, Resets, iSpeed: Integer;
  FreqData: array[441..44100] of record
    Resets, Hundreds: Integer;
  end;





implementation

uses
  Forms;

{ TStreamThread }

procedure TStreamThread.Execute;
begin
  repeat
    Reps := 0;
    OpenWriteAtFreq(DI, ClockHz);
    repeat
      //This is where waveform generation would go, if it were in this thread.

      WriteFrame(DI, StreamWave);
      Inc(Reps);
      if Reps >= 100 then begin
        Inc(FreqData[iSpeed].Resets, Resets);
        Inc(FreqData[iSpeed].Hundreds);
        Resets := 0;

        iSpeed := Random(High(FreqData) - Low(FreqData) + 1);
        ClockHz := iSpeed * 100;
        PostMessage(Application.MainForm.Handle, AM_HZ, iSpeed * 100, 0);

        Break;
      end;
    until Terminated;
    CloseWrite(DI);
  until Terminated;

  bDone := True;
end;

end.
